/*

    Prime Factor FFT
    Copyright (C) 1995 Colorado School of Mines. All rights reserved.
    Copyright (C) 2001 Jussi Laako

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Source converted from cwplib (by Dave Hale and Lydia Deng / Colorado
    School of Mines).

*/


#ifndef PFAFFT_HH
    #define PFAFFT_HH

    class clPFAFFT
    {
            double dPI;
        public:
            clPFAFFT ();
            ~clPFAFFT ();
            long npfa (long);
            long npfao (long, long);
            long npfar (long);
            long npfaro (long, long);
            void pfacc (int, long, float *);
            void pfacc (int, long, double *);
            void pfarc (int, long, float *, float *);
            void pfarc (int, long, double *, double *);
            void pfacr (int, long, float *, float *);
            void pfacr (int, long, double *, double *);
            void pfa2cc (int, int, long, long, float *);
            void pfa2cc (int, int, long, long, double *);
            void pfa2rc (int, int, long, long, float *, float *);
            void pfa2rc (int, int, long, long, double *, double *);
            void pfa2cr (int, int, long, long, float *, float *);
            void pfa2cr (int, int, long, long, double *, double *);
            void pfamcc (int, long, long, long, long, float *);
            void pfamcc (int, long, long, long, long, double *);
    };

#endif
